// kontroll.c
// 1998-02-07 programmeerimisolmpiaadi noorema rhma 1. lesande testija
// Ahto Truu

#include <stdio.h>
#include <stdlib.h>

int main (int argc, char **argv)
{
	FILE *f;
	struct {char *s; int n;} x[] =
		{"Formaadiviga ", 0,
		 "Vale isik    ", 0,
		 "Isik puudu   ", 0,
		 "Vale kontakt ", 0,
		 "Kontakt puudu", 0};
	struct {int n; struct {int n, a, *k, v, x;} *p;} s;
	struct {int m, a, k;} v;
	char b[0x1000], *p;
	int i, j, c, r;

	if (argc != 3) {
		fprintf (stderr, "Sntaks on: %s sisendfail vljundfail\n", argv[0]);
		return 1;
	}

	if (!(f = fopen (argv[1], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[1]);
		return 2;
	}

	if (fscanf (f, "%d", &s.n) != 1 || s.n < 1 || s.n > 5000) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
		return 2;
	}

	if (!(s.p = malloc (s.n * sizeof (*s.p))) && s.n) {
		fprintf (stderr, "Ei jtku mlu\n");
		return 4;
	}

	for (i = 0; i < s.n; ++i) {
		if (fscanf (f, "%d", &s.p[i].n) != 1 || s.p[i].n < 0 || s.p[i].n > 1) {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		if (fscanf (f, "%d", &s.p[i].a) != 1 || s.p[i].n < 0 || s.p[i].n > 500) {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		if (!(s.p[i].k = malloc (s.p[i].a * sizeof (*s.p[i].k))) && s.p[i].a) {
			fprintf (stderr, "Ei jtku mlu\n");
			return 4;
		}

		for (j = 0; j < s.p[i].a; ++j) {
			if (fscanf (f, "%d", &s.p[i].k[j]) != 1 || s.p[i].k[j] < 1 || s.p[i].k[j] > s.n) {
				fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
				return 2;
			}
		}
	}

	fclose (f);

	for (i = 0; i < s.n; ++i) {
		s.p[i].x = 0;
		if (!s.p[i].n)
			for (j = 0; j < s.p[i].a; ++j)
				s.p[i].x += s.p[s.p[i].k[j] - 1].n;
		s.p[i].v = !s.p[i].n && s.p[i].x;
	}

	if (!(f = fopen (argv[2], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[2]);
		return 2;
	}

	while (p = fgets (b, sizeof (b), f)) {
		if (sscanf (p, "%d%n", &v.m, &c) != 1) {
			++x[0].n;
			continue;
		}
		p += c;

		if (v.m < 1 || v.m > s.n || !s.p[v.m - 1].v) {
			++x[1].n;
			continue;
		}
		--s.p[v.m - 1].v;

		if (sscanf (p, "%d%n", &v.a, &c) != 1) {
			++x[0].n;
			continue;
		}
		p += c;

		while ((r = sscanf (p, "%d%n", &v.k, &c)) == 1) {
			p += c;
			--v.a;

			for (i = 0; i < s.p[v.m - 1].a; ++i)
				if (s.p[v.m - 1].k[i] == v.k)
					break;

			if (i == s.p[v.m - 1].a || !s.p[v.k - 1].n) {
				++x[3].n;
				continue;
			}

			s.p[v.m - 1].k[i] = 0;
			--s.p[v.m - 1].x;
		}

		if (v.a || r != EOF)
			++x[0].n;
	}

	if (!feof (f)) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[2]);
		return 3;
	}
		
	fclose (f);

	for (i = 0; i < s.n; ++i) {
		x[2].n += s.p[i].v;
		x[4].n += s.p[i].x;
	}

	puts ("Vigade statistika:");
	for (i = 0; i < sizeof (x) / sizeof (*x); ++i)
		printf ("\t%s : %5d\n", x[i].s, x[i].n);

	if (x[0].n || x[1].n || x[2].n)
		puts ("Punkte: 0");
	else if (x[3].n || x[4].n)
		puts ("Punkte: 1");
	else
		puts ("Punkte: 3");

	return 0;
}