// kontroll.c
// 1998-02-07 programmeerimisolmpiaadi noorema rhma 2. lesande testija
// Ahto Truu

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

int icomp (void *p1, void *p2)
{
	return *(int *)p1 - *(int *)p2;
}

int pcomp (void *p1, void *p2)
{
	if ((*(int **)p1)[0] == (*(int **)p2)[0])
		return (*(int **)p1)[1] - (*(int **)p2)[1];
	else
		return (*(int **)p1)[0] - (*(int **)p2)[0];
}

int rcomp (void *p1, void *p2)
{
	int i;
	for (i = 0; i < 4; ++i)
		if ((*(int **)p1)[i] != (*(int **)p2)[i])
			return (*(int **)p1)[i] - (*(int **)p2)[i];
	return 0;
}

int main (int argc, char **argv)
{
	FILE *f;
	struct {char *s; int n;} x[] =
		{"Formaadiviga   ", 0,
		 "Vale punkt     ", 0,
		 "Vale ristklik ", 0,
		 "Ristklik puudu", 0};
	struct {int n, **p;} s;
	struct {int n, m, **p;} t = {0, 0, 0};
	int v[4], *w = v;
	char b[0x1000], *p;
	int i, j, **k, **l, c;

	if (argc != 3) {
		fprintf (stderr, "Sntaks on: %s sisendfail vljundfail\n", argv[0]);
		return 1;
	}

	if (!(f = fopen (argv[1], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[1]);
		return 2;
	}

	if (!fgets (b, sizeof (b), f) || sscanf (b, "%d%n", &s.n, &c) != 1 || b[c] != '\n'
			|| s.n < 1 || s.n > 100) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
		return 2;
	}

	if (!(s.p = malloc (s.n * sizeof (*s.p))) && s.n) {
		fprintf (stderr, "Ei jtku mlu\n");
		return 4;
	}

	for (i = 0; i < s.n; ++i) {
		if (!(p = fgets (b, sizeof (b), f))) {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		if (!(s.p[i] = malloc (3 * sizeof (*s.p[i])))) {
			fprintf (stderr, "Ei jtku mlu\n");
			return 4;
		}

		if (sscanf (p, "%d%d%n", &s.p[i][0], &s.p[i][1], &c) != 2 || p[c] != '\n') {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		s.p[i][2] = i + 1;
	}

	fclose (f);

	qsort (s.p, s.n, sizeof (*s.p), pcomp);

	for (i = 0; i < s.n; ++i)
		for (j = 0; j < s.n; ++j)
			if (s.p[i][0] < s.p[j][0] && s.p[i][1] < s.p[j][1]) {
				v[0] = s.p[i][0]; v[1] = s.p[j][1];
				k = bsearch (&w, s.p, s.n, sizeof (*s.p), pcomp);
				v[0] = s.p[j][0]; v[1] = s.p[i][1];
				l = bsearch (&w, s.p, s.n, sizeof (*s.p), pcomp);
				if (k && l) {
					if (t.n == t.m) {
						if (t.m) t.m *= 2; else ++t.m;
						if (!(t.p = realloc (t.p, t.m * sizeof (*t.p))) && t.m) {
							fprintf (stderr, "Ei jtku mlu\n");
							return 4;
						}
					}

					if (!(t.p[t.n] = malloc (5 * sizeof (*t.p[t.n])))) {
						fprintf (stderr, "Ei jtku mlu\n");
						return 4;
					}

					t.p[t.n][0] = s.p[i][2];
					t.p[t.n][1] = s.p[j][2];
					t.p[t.n][2] = (*k)[2];
					t.p[t.n][3] = (*l)[2];
					t.p[t.n][4] = 1;

					++t.n;
				}
			}

	for (i = 0; i < t.n; ++i)
		qsort (t.p[i], 4, sizeof (*t.p[i]), icomp);

	qsort (t.p, t.n, sizeof (*t.p), rcomp);

	if (!(f = fopen (argv[2], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[2]);
		return 2;
	}

	while (p = fgets (b, sizeof (b), f)) {
		for (i = 0; i < 4; ++i) {
			if (sscanf (p, "%d%n", v + i, &c) != 1 || *(p += c) != "   \n"[i]) {
				++x[0].n;
				break;
			}

			if (v[i] < 1 || v[i] > s.n) {
				++x[1].n;
				break;
			}
		}

		if (i < 4)
			continue;

		qsort (v, 4, sizeof (*v), icomp);

		if (!(k = bsearch (&w, t.p, t.n, sizeof (*t.p), rcomp)) || !(*k)[4]) {
			++x[2].n;
			continue;
		}

		--(*k)[4];
	}

	if (!feof (f)) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[2]);
		return 3;
	}
		
	fclose (f);

	for (i = 0; i < t.n; ++i)
		x[3].n += t.p[i][4];

	puts ("Vigade statistika:");
	for (i = 0; i < sizeof (x) / sizeof (*x); ++i)
		printf ("\t%s : %5d\n", x[i].s, x[i].n);

	if (x[0].n || x[1].n || x[2].n || x[3].n)
		puts ("Punkte: 0");
	else
		puts ("Punkte: 3");

	return 0;
}