// kontroll.c
// 1998-02-07 programmeerimisolmpiaadi vanema rhma 1. lesande testija
// Ahto Truu

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

typedef struct {char g; int n;} is;

int comp (void *p1, void *p2)
{
	if ((*(is **)p1)[0].g == (*(is **)p2)[0].g)
		if ((*(is **)p1)[0].n == (*(is **)p2)[0].n)
			if ((*(is **)p1)[1].g == (*(is **)p2)[1].g)
				return (*(is **)p1)[1].n - (*(is **)p2)[1].n;
			else
				return (*(is **)p1)[1].g - (*(is **)p2)[1].g;
		else
			return (*(is **)p1)[0].n - (*(is **)p2)[0].n;
	else
		return (*(is **)p1)[0].g - (*(is **)p2)[0].g;
}

int main (int argc, char **argv)
{
	FILE *f;
	struct {char *s; int n;} x[] =
		{"Formaadiviga ", 0,
		 "Vale isik    ", 0,
		 "Isik puudu   ", 0,
		 "Vale kontakt ", 0};
	struct {int na, nb, nc, n; is **p;} s;
	struct {int nb, *b, nc, *c;} t;
	is v[3], *w;
	char b[0x1000], *p;
	int i, j, c;

	if (argc != 3) {
		fprintf (stderr, "Sntaks on: %s sisendfail vljundfail\n", argv[0]);
		return 1;
	}

	if (!(f = fopen (argv[1], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[1]);
		return 2;
	}

	if (!fgets (b, sizeof (b), f) || sscanf (b, "%d%d%d%n", &s.na, &s.nb, &s.nc, &c) != 3 || b[c] != '\n'
			|| s.na < 1 || s.na > 1000
			|| s.nb < 1 || s.nb > 1000
			|| s.nc < 1 || s.nc > 1000) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
		return 2;
	}

	if (!fgets (b, sizeof (b), f) || sscanf (b, "%d%n", &s.n, &c) != 1 || b[c] != '\n'
			|| s.n < 1 || s.n > 10000) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
		return 2;
	}

	if (!(s.p = malloc (s.n * sizeof (*s.p))) && s.n) {
		fprintf (stderr, "Ei jtku mlu\n");
		return 4;
	}

	for (i = 0; i < s.n; ++i) {
		if (!(p = fgets (b, sizeof (b), f))) {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		if (!(s.p[i] = malloc (2 * sizeof (*s.p[i])))) {
			fprintf (stderr, "Ei jtku mlu\n");
			return 4;
		}

		// see ei ole tegelikult pris kuulikindel koht
		if (sscanf (p, "%c%d%n", &s.p[i][0].g, &s.p[i][0].n, &c) != 2 || *(p += c) != ' ') {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}
		if (sscanf (++p, "%c%d%n", &s.p[i][1].g, &s.p[i][1].n, &c) != 2 || p[c] != '\n') {
			fprintf (stderr, "Viga faili %s lugemisel\n", argv[1]);
			return 2;
		}

		if (s.p[i][0].g < s.p[i][1].g) {
			s.p[i][0].g ^= s.p[i][1].g ^= s.p[i][0].g ^= s.p[i][1].g;
			s.p[i][0].n ^= s.p[i][1].n ^= s.p[i][0].n ^= s.p[i][1].n;
		}
	}

	fclose (f);

	qsort (s.p, s.n, sizeof (*s.p), comp);

	if (!(t.b = calloc (t.nb = s.nb, sizeof (*t.b))) && t.nb) {
		fprintf (stderr, "Ei jtku mlu\n");
		return 4;
	}

	for (i = 0; i < s.n; ++i)
		if (s.p[i][0].g == 'B' && s.p[i][1].g == 'A')
			t.b[s.p[i][0].n - 1] = 1;

	if (!(t.c = calloc (t.nc = s.nc, sizeof (*t.c))) && t.nc) {
		fprintf (stderr, "Ei jtku mlu\n");
		return 4;
	}

	for (i = 0; i < s.n; ++i)
		if (s.p[i][0].g == 'C') {
			if (s.p[i][1].g == 'A')
				t.c[s.p[i][0].n - 1] = -1;
			if (s.p[i][1].g == 'B')
				if (!t.c[s.p[i][0].n - 1] && t.b[s.p[i][1].n - 1])
					t.c[s.p[i][0].n - 1] = 1;
		}

	if (!(f = fopen (argv[2], "r"))) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[2]);
		return 2;
	}

	while (p = fgets (b, sizeof (b), f)) {
		if (sscanf (p, "%c%d%n", &v[0].g, &v[0].n, &c) != 2 || *(p += c) != ' ' || v[0].g != 'C') {
			++x[0].n;
			continue;
		}
		if (sscanf (++p, "%c%d%n", &v[1].g, &v[1].n, &c) != 2 || *(p += c) != ' ' || v[1].g != 'B') {
			++x[0].n;
			continue;
		}
		if (sscanf (++p, "%c%d%n", &v[2].g, &v[2].n, &c) != 2 || p[c] != '\n' || v[2].g != 'A') {
			++x[0].n;
			continue;
		}

		if (v[0].n < 1 || v[0].n > s.nc || !t.c[v[0].n - 1]) {
			++x[1].n;
			continue;
		}
		t.c[v[0].n - 1] = 0;

		w = v;
		if (!bsearch (&w, s.p, s.n, sizeof (*s.p), comp))
			++x[3].n;
		++w;
		if (!bsearch (&w, s.p, s.n, sizeof (*s.p), comp))
			++x[3].n;
	}

	if (!feof (f)) {
		fprintf (stderr, "Viga faili %s lugemisel\n", argv[2]);
		return 3;
	}
		
	fclose (f);

	for (i = 0; i < t.nc; ++i)
		if (t.c[i] == 1)
			++x[2].n;

	puts ("Vigade statistika:");
	for (i = 0; i < sizeof (x) / sizeof (*x); ++i)
		printf ("\t%s : %5d\n", x[i].s, x[i].n);

	if (x[0].n || x[1].n || x[2].n)
		puts ("Punkte: 0");
	else if (x[3].n)
		puts ("Punkte: 1");
	else
		puts ("Punkte: 3");

	return 0;
}